<template>
<div class="grid">
  <slot name="GridHeader" :config="gridConfig">
    <GridHeader />
  </slot>
  <slot name="GridBody" :config="gridConfig">
    <GridBody />
  </slot>
  <slot name="GridFooter" :config="gridConfig" :activeData="activeData">
    <GridFooter />
  </slot>
</div>
</template>
<script lang="ts">
import Vue from 'vue';
import {
  Component, Prop, Provide, Watch,
} from 'vue-property-decorator';
import { namespace } from 'vuex-class';
import GridConfig, { GridRow } from './GridConfig';
import {
  GridHeader, GridFooter, GridBody,
} from '.';

const grid = namespace('grid');

@Component({
  components: {
    GridHeader, GridBody, GridFooter,
  },
})
export default class Grid extends Vue {
  @Prop({ required: true }) config!: GridConfig

  @Prop({ required: true }) data!: Array<GridRow>

  @Provide('gridConfig') gridConfig = this.config

  @Provide('gridFilters') gridFilters = this.config.filters

  @Provide('gridColumns') gridColumns = this.config.columns

  @Provide('gridSortList') gridSortList = this.config.sortList

  @grid.Action
  public setGridData!: (data) => void

  @grid.Getter
  public activeData!: Array<GridRow>

  @Watch('data')
  onDataChange() {
    this.setGridData(this.data);
  }
}
</script>
